﻿'
' Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
'
Imports MindFusion.Scheduling.WebForms
Imports System.Xml
Imports System.IO
Imports MindFusion.Scheduling
Imports System.Drawing

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            ' Initialize dates to be today
            _calendar.TimetableSettings.Dates.Clear()
            For i As Integer = 0 To 4
                _calendar.TimetableSettings.Dates.Add(New TimetableDate(DateTime.Today + New TimeSpan(i * TimeSpan.TicksPerDay)))
            Next
            Session.Add("_dates", _calendar.TimetableSettings.Dates)

            _calendar.[Date] = DateTime.Today
            _calendar.EndDate = DateTime.Today + TimeSpan.FromDays(60)
			
			InitSettings()

			_calendar.ItemSettings.ItemsVisible = State.Enabled
			_calendar.ItemSettings.HeaderSize = Unit.Pixel(25)
			_calendar.ItemSettings.Size = 15
			_calendar.ItemSettings.Spacing = 2
			_calendar.ItemSettings.ShowContinuationArrows = State.Enabled
			_calendar.ItemSettings.ShowMoreItemsCue = State.Enabled
			_calendar.ItemSettings.ShowReminderIcons = State.Enabled

            ShowInfo()

            AddScheduleData()

            PopulateListBox()

            UpdateControls()
        Else
            Dim selection As Selection = Calendar2.Selection
            If Not selection.IsEmpty Then
                _calendar.TimetableSettings.Dates.Clear()
                Dim [date] As DateTime = selection.Ranges(0)
                Dim [end] As DateTime = selection.Ranges(1)
                While [date] < [end]
                    Dim tDate As New TimetableDate([date])
                    _calendar.TimetableSettings.Dates.Add(tDate)
                    [date] += TimeSpan.FromDays(1)
                    Session("_dates") = _calendar.TimetableSettings.Dates
                End While
                selection.Reset()
            Else
                Dim temp As TimetableDateCollection = DirectCast(Session("_dates"), TimetableDateCollection)
				If temp IsNot Nothing Then
					_calendar.TimetableSettings.Dates.Clear()
					For Each [date] In temp
						_calendar.TimetableSettings.Dates.Add(DirectCast([date], TimetableDate))
					Next
				End If
            End If
        End If

    End Sub
	
	Private Sub InitSettings()
		_calendar.WeekRangeSettings.ViewStyle = WeekRangeViewStyle.WeekPerRow
		_calendar.WeekRangeSettings.HeaderStyle = WeekRangeHeaderStyle.Title
		_calendar.WeekRangeSettings.DayNamesHeaderHeight = Unit.Pixel(16)
		_calendar.WeekRangeSettings.DaySettings.ShowToday = State.Enabled
		_calendar.WeekRangeSettings.DaySettings.GeneralFormat = "d "
		_calendar.WeekRangeSettings.DaySettings.FirstDayOfMonthFormat = "d "
		_calendar.WeekRangeSettings.DaySettings.FirstDayOfYearFormat = "d "

		_calendar.ListViewSettings.ShowNavigationButtons = State.Enabled
		_calendar.ListViewSettings.MainHeaderSize = Unit.Pixel(30)
		_calendar.ListViewSettings.CellSettings.ShowToday = State.Enabled
		_calendar.ListViewSettings.CellSettings.GeneralFormat = "d "
		_calendar.ListViewSettings.CellSettings.FirstDayOfMonthFormat = "d "
		_calendar.ListViewSettings.CellSettings.FirstDayOfYearFormat = "d "

		_calendar.MonthSettings.HeaderStyle = MonthHeaderStyles.Title Or MonthHeaderStyles.MonthButtons Or MonthHeaderStyles.YearButtons
		_calendar.MonthSettings.MainHeaderHeight = Unit.Pixel(30)
		_calendar.MonthSettings.DayNamesHeaderHeight = Unit.Pixel(20)
		_calendar.MonthSettings.WeekNumbersHeaderWidth = Unit.Pixel(15)
		_calendar.MonthSettings.DaySettings.ShowToday = State.Enabled

		_calendar.MonthRangeSettings.HeaderSpacing = 2
		_calendar.MonthRangeSettings.MonthSpacing = 2
		_calendar.MonthRangeSettings.HeaderHeight = Unit.Pixel(30)

		_calendar.TimetableSettings.ShowNavigationButtons = State.Enabled
		_calendar.TimetableSettings.DayHeaderMinSize = Unit.Pixel(16)
		_calendar.TimetableSettings.MainHeaderSize = Unit.Pixel(30)
		_calendar.TimetableSettings.GroupHeaderSize = Unit.Pixel(20)
		_calendar.TimetableSettings.TimelineSize = Unit.Pixel(40)
	End Sub

    ''' <summary>
    ''' Hides or shows relevant for the current view property controls.
    ''' </summary>
    Private Sub ShowInfo()
        Select Case _calendar.CurrentView
            Case CalendarView.List
				infoText.InnerHtml = listInfo
                pnlSingle.Visible = False
                pnlMRange.Visible = False
                pnlTimetable.Visible = False
                pnlList.Visible = True
                pnlWeek.Visible = False
                pnlResource.Visible = False
                btnGroupBy.Visible = False
                cblItemSettings.Items(2).Enabled = True
                is_headerSize.Visible = False
                lblis_headerSize.Visible = False
                Exit Select
            Case CalendarView.MonthRange
				infoText.InnerHtml = monthRangeInfo
                pnlSingle.Visible = True
                pnlMRange.Visible = True
                pnlTimetable.Visible = False
                pnlList.Visible = False
                pnlWeek.Visible = False
                pnlResource.Visible = False
                btnGroupBy.Visible = False
                cblSinlgeMonth.Items(0).Enabled = False
                cblSinlgeMonth.Items(1).Enabled = False
                cblItemSettings.Items(2).Enabled = True
                is_headerSize.Visible = False
                lblis_headerSize.Visible = False
                Exit Select
            Case CalendarView.SingleMonth
				infoText.InnerHtml = singleMonthInfo
                pnlSingle.Visible = True
                pnlMRange.Visible = False
                pnlTimetable.Visible = False
                pnlList.Visible = False
                pnlWeek.Visible = False
                pnlResource.Visible = False
                btnGroupBy.Visible = False
                cblSinlgeMonth.Items(0).Enabled = True
                cblSinlgeMonth.Items(1).Enabled = True
                cblItemSettings.Items(2).Enabled = True
                is_headerSize.Visible = False
                lblis_headerSize.Visible = False
                Exit Select
            Case CalendarView.Timetable
				infoText.InnerHtml = timetableInfo
                pnlSingle.Visible = False
                pnlMRange.Visible = False
                pnlTimetable.Visible = True
                pnlList.Visible = False
                pnlWeek.Visible = False
                pnlResource.Visible = False
                btnGroupBy.Visible = True
                cblItemSettings.Items(2).Enabled = True
                is_headerSize.Visible = True
                lblis_headerSize.Visible = True
                Exit Select
            Case CalendarView.WeekRange
                If _calendar.WeekRangeSettings.ViewStyle = WeekRangeViewStyle.WeekPerRow OrElse _calendar.WeekRangeSettings.ViewStyle = WeekRangeViewStyle.Unspecified Then
					infoText.InnerHtml = weekRangeInfo
                    wr_subHeaderSize.Visible = True
                    cblWeekRange.Items(1).Enabled = True
                    lblwr_subHeaderSize.Visible = True
                    wr_visibleRows.Visible = True
                    lblwr_visibleRows.Visible = True
                Else
					infoText.InnerHtml = singleWeekInfo
                    wr_subHeaderSize.Visible = False
                    cblWeekRange.Items(1).Enabled = False
                    lblwr_subHeaderSize.Visible = False
                    wr_visibleRows.Visible = False
                    lblwr_visibleRows.Visible = False
                End If
                pnlSingle.Visible = False
                pnlMRange.Visible = False
                pnlTimetable.Visible = False
                pnlList.Visible = False
                pnlWeek.Visible = True
                pnlResource.Visible = False
                btnGroupBy.Visible = False
                cblItemSettings.Items(2).Enabled = True
                is_headerSize.Visible = False
                lblis_headerSize.Visible = False
                Exit Select
            Case CalendarView.ResourceView
				infoText.InnerHtml = resourceInfo
                pnlSingle.Visible = False
                pnlMRange.Visible = False
                pnlTimetable.Visible = False
                pnlList.Visible = False
                pnlWeek.Visible = False
                pnlResource.Visible = True
                btnGroupBy.Visible = True
                r_mtunit.Enabled = r_timelines.SelectedIndex > 0
                r_mtcount.Enabled = r_timelines.SelectedIndex > 0
                r_mtsize.Enabled = r_timelines.SelectedIndex > 0
                r_ttunit.Enabled = r_timelines.SelectedIndex > 1
                r_ttcount.Enabled = r_timelines.SelectedIndex > 1
                r_ttsize.Enabled = r_timelines.SelectedIndex > 1
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub

    ''' <summary>
    ''' Generates predefined Schedule data - appointments, contacts and locations.
    ''' </summary>
    Private Sub AddScheduleData()
        Dim dates As TimetableDateCollection = _calendar.TimetableSettings.Dates

        Dim app As Appointment = Nothing
        'Recurrence recurrence = null;
        Dim reminder As Reminder = Nothing
        Dim [date] As DateTime = DateTime.Today
        Dim theDate As New TimetableDate()
        Dim random As New Random(DateTime.Now.Millisecond)

        '#Region "Contacts"
        Dim c As Contact = Nothing

        c = New Contact()
        c.FirstName = "Tom"
        c.LastName = "Miles"
        _calendar.Schedule.Contacts.Add(c)

        c = New Contact()
        c.FirstName = "Jimmy"
        c.LastName = "King"
        _calendar.Schedule.Contacts.Add(c)

        c = New Contact()
        c.FirstName = "Elisabeth"
        c.LastName = "Tailor"
        _calendar.Schedule.Contacts.Add(c)
        '#End Region

        '#Region "Locations"
        Dim l1 As Location = Nothing
        Dim l2 As Location = Nothing

        l1 = New Location()
        l1.Country = "Atlantic Ocean"
        l1.Name = "25° 0′ 0″ N, 71° 0′ 0″ W"
        _calendar.Schedule.Locations.Add(l1)
        l2 = New Location()
        l2.Country = "USA"
        l2.Name = "Area 51"
        l2.ZipCode = "89044"
        l2.State = "Nevada"
        _calendar.Schedule.Locations.Add(l2)
        '#End Region

        '#Region "Create some events"

        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 8, 30, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 10, 30, 0)
        app.HeaderText = "Meet George"
        app.DescriptionText = "This is the seventh time I promise George. This time I should go."
        app.Contacts.Add(_calendar.Schedule.Contacts(random.[Next](0, 2)))
        _calendar.Schedule.Items.Add(app)

        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 13, 15, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 14, 0, 0)
        app.HeaderText = "Visit the dentist"
        app.DescriptionText = "This reminder is rather pointless, since my tooth is a reminder on its own."
        app.Location = l1
        _calendar.Schedule.Items.Add(app)

        ' Add a recurring appointment
        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 12, 0, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 13, 30, 0)
        app.HeaderText = "Lunch with Laura"
        app.Location = l2
        app.DescriptionText = "Never to forget the appointment with the boss."

        ' The recurrence
        'recurrence = new Recurrence();
        '			recurrence.Pattern = RecurrencePattern.Weekly;
        '			recurrence.DaysOfWeek = DaysOfWeek.Wednesday;
        '			recurrence.StartDate = date;
        '			recurrence.RecurrenceEnd = RecurrenceEnd.Never;
        '			app.Recurrence = recurrence;

        _calendar.Schedule.Items.Add(app)

        ' Add an appointment with reminder
        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.AllDayEvent = True
        app.StartTime = [date]
        app.EndTime = [date] + TimeSpan.FromDays(1)
        app.HeaderText = "William's birthday"

        reminder = New Reminder()
        reminder.Message = "It's " + app.HeaderText & " soon!"
        reminder.Type = ReminderType.Leading
        reminder.TimeInterval = TimeSpan.FromDays(1)
        app.Reminder = reminder
        app.Contacts.Add(_calendar.Schedule.Contacts(random.[Next](0, 2)))
        _calendar.Schedule.Items.Add(app)

        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 10, 0, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 16, 0, 0)
        app.HeaderText = "Have fun!"
        app.DescriptionText = "Working hard, but sometimes we need to rest."
        app.Contacts.Add(_calendar.Schedule.Contacts(random.[Next](0, 2)))
        _calendar.Schedule.Items.Add(app)

        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 18, 20, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 18, 35, 0)
        app.HeaderText = "Prepare the dinner!"
        app.DescriptionText = "Yeah!"
        _calendar.Schedule.Items.Add(app)

        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 17, 0, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 17, 45, 0)
        app.HeaderText = "Get the children from the kindergarten!"
        app.DescriptionText = "Yeah!"
        _calendar.Schedule.Items.Add(app)

        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 17, 30, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 21, 0, 0)
        app.HeaderText = "Arrange the house payments!"
        app.DescriptionText = "Yeah!"
        app.Contacts.Add(_calendar.Schedule.Contacts(random.[Next](0, 2)))
        _calendar.Schedule.Items.Add(app)

        theDate = dates(random.[Next]() Mod dates.Count)
        [date] = theDate.Value
        app = New Appointment()
        app.StartTime = New DateTime([date].Year, [date].Month, [date].Day, 7, 30, 0)
        app.EndTime = New DateTime([date].Year, [date].Month, [date].Day, 8, 20, 0)
        app.HeaderText = "Drive kids to school!"
        app.DescriptionText = "Yeah!"
        _calendar.Schedule.Items.Add(app)
        '#End Region
    End Sub

    ''' <summary>
    ''' Updates the contents of the contacts and locations listboxes.
    ''' </summary>
    Private Sub PopulateListBox()
        lstContacts.Items.Clear()
        lstLocations.Items.Clear()

        For Each c As Contact In _calendar.Schedule.Contacts
            Dim selected As Boolean = _calendar.Contacts.Contains(c)
            lstContacts.Items.Add(New ListItem() With { _
              .Text = c.FirstName + " " + c.LastName, _
              .Value = c.Id, _
              .Selected = selected _
            })
        Next

        For Each l As Location In _calendar.Schedule.Locations
            Dim selected As Boolean = _calendar.Locations.Contains(l)
            lstLocations.Items.Add(New ListItem() With { _
              .Text = l.Name, _
              .Value = l.Id, _
              .Selected = selected _
            })
        Next
    End Sub

    ''' <summary>
    ''' Update values in settings controls on the page.
    ''' </summary>
    Private Sub UpdateControls()
        sm_mainHeaderSize.Text = _calendar.MonthSettings.MainHeaderHeight.Value.ToString()
        sm_subHeaderSize.Text = _calendar.MonthSettings.DayNamesHeaderHeight.Value.ToString()
        sm_weekHeaderSize.Text = _calendar.MonthSettings.WeekNumbersHeaderWidth.Value.ToString()
        mr_numberOfMonths.Text = _calendar.MonthRangeSettings.NumberOfMonths.ToString()
        mr_monthsPerRow.Text = _calendar.MonthRangeSettings.MonthsPerRow.ToString()
        mr_VisibleRows.Text = _calendar.MonthRangeSettings.VisibleRows.ToString()
        mr_headerHeight.Text = _calendar.MonthRangeSettings.HeaderHeight.Value.ToString()
        mr_headerSpacing.Text = _calendar.MonthRangeSettings.HeaderSpacing.ToString()
        mr_monthSpacing.Text = _calendar.MonthRangeSettings.MonthSpacing.ToString()
        tt_mainHeaderSize.Text = _calendar.TimetableSettings.MainHeaderSize.Value.ToString()
        tt_subHeaderSize.Text = _calendar.TimetableSettings.GroupHeaderSize.Value.ToString()
        tt_timelineSize.Text = _calendar.TimetableSettings.TimelineSize.Value.ToString()
        tt_cellSize.Text = _calendar.TimetableSettings.CellSize.Value.ToString()
        tt_cellTime.Text = _calendar.TimetableSettings.CellTime.Minutes.ToString()
        lv_headerSize.Text = _calendar.ListViewSettings.MainHeaderSize.Value.ToString()
        lv_numberOfCells.Text = _calendar.ListViewSettings.NumberOfCells.ToString()
        lv_visibleCells.Text = _calendar.ListViewSettings.VisibleCells.ToString()
        lv_dateFormat.Text = _calendar.ListViewSettings.CellSettings.GeneralFormat
        lv_navButtons.Checked = _calendar.ListViewSettings.ShowNavigationButtons = State.Enabled
        wr_headerSize.Text = _calendar.WeekRangeSettings.MainHeaderHeight.Value.ToString()
        wr_subHeaderSize.Text = _calendar.WeekRangeSettings.DayNamesHeaderHeight.Value.ToString()
        wr_totalDays.Text = (_calendar.EndDate - _calendar.[Date]).TotalDays.ToString()
        wr_visibleRows.Text = _calendar.WeekRangeSettings.VisibleRows.ToString()
        r_visibleCells.Text = _calendar.ResourceViewSettings.VisibleCells.ToString()
        r_groupHeaderSize.Text = _calendar.ResourceViewSettings.GroupHeaderSize.Value.ToString()
        r_ttcount.Text = _calendar.ResourceViewSettings.TopTimelineSettings.UnitCount.ToString()
        r_mtcount.Text = _calendar.ResourceViewSettings.MiddleTimelineSettings.UnitCount.ToString()
        r_btcount.Text = _calendar.ResourceViewSettings.BottomTimelineSettings.UnitCount.ToString()
        r_ttsize.Text = _calendar.ResourceViewSettings.TopTimelineSettings.Size.ToString()
        r_mtsize.Text = _calendar.ResourceViewSettings.MiddleTimelineSettings.Size.ToString()
        r_btsize.Text = _calendar.ResourceViewSettings.BottomTimelineSettings.Size.ToString()
        is_size.Text = _calendar.ItemSettings.Size.ToString()
        is_spacing.Text = _calendar.ItemSettings.Spacing.ToString()
        is_headerSize.Text = _calendar.ItemSettings.HeaderSize.Value.ToString()
    End Sub

    ''' <summary>
    ''' Change calendar's CurrentView.
    ''' </summary>
    Protected Sub lstCurrentView_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        If ddl.SelectedIndex <> -1 Then
            If ddl.SelectedValue <> "SingleWeek" Then
                _calendar.CurrentView = DirectCast([Enum].Parse(GetType(CalendarView), ddl.SelectedValue), CalendarView)
                If ddl.SelectedValue = "WeekRange" Then
                    _calendar.WeekRangeSettings.ViewStyle = WeekRangeViewStyle.WeekPerRow
                End If
            Else
                _calendar.CurrentView = CalendarView.WeekRange
                _calendar.WeekRangeSettings.ViewStyle = WeekRangeViewStyle.SingleWeek
            End If
			
			InitSettings()
			
			UpdateControls()

            ShowInfo()
        End If
    End Sub

    ''' <summary>
    ''' Change calendar's Theme
    ''' </summary>
    Protected Sub lstTheme_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        If ddl.SelectedIndex <> -1 Then
            _calendar.Theme = DirectCast([Enum].Parse(GetType(ThemeType), ddl.SelectedItem.Text), ThemeType)
            Calendar2.Theme = DirectCast([Enum].Parse(GetType(ThemeType), ddl.SelectedItem.Text), ThemeType)
        End If
    End Sub

    ''' <summary>
    ''' Clears the calendar's Schedule
    ''' </summary>
    Protected Sub btnClear_Click(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.Schedule.Clear()
        PopulateListBox()
    End Sub

    ''' <summary>
    ''' Loads calendar's Schedule from file
    ''' </summary>
    Protected Sub btnLoad_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim FileName As String = Server.MapPath(".") & "\calendar.xml"
        If Not File.Exists(FileName) Then
            Return
        End If
        Dim document As New XmlDocument()
        document.Load(FileName)
        _calendar.Schedule.LoadFromXml(document)
        PopulateListBox()
    End Sub

    ''' <summary>
    ''' Saves calendar's Schedule to file
    ''' </summary>
    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim FileName As String = Server.MapPath(".") & "\calendar.xml"
        Dim document As New XmlDocument()
        _calendar.Schedule.SaveToXml(document)
        document.Save(FileName)
        PopulateListBox()
    End Sub

    Protected Sub btnAddCon_Click(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(tbConFName.Text + tbConLName.Text) Then
            Dim c As New Contact() With { _
              .FirstName = tbConFName.Text, _
              .LastName = tbConLName.Text _
            }
            _calendar.Schedule.Contacts.Add(c)
            tbConFName.Text = [String].Empty
            tbConLName.Text = [String].Empty
            PopulateListBox()
        End If
    End Sub

    Protected Sub btnDelCon_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim id As String = lstContacts.SelectedValue
        If Not [String].IsNullOrEmpty(id) Then
            Dim c As Contact = _calendar.Schedule.Contacts(id)
            If c IsNot Nothing Then
                _calendar.Schedule.Contacts.Remove(c)
				If _calendar.Contacts.Contains(c) Then
					_calendar.Contacts.Remove(c)
				End If
                tbConFName.Text = [String].Empty
                tbConLName.Text = [String].Empty
                PopulateListBox()

            End If
        End If
    End Sub

    Protected Sub btnAddLoc_Click(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(tbLocName.Text) Then
            Dim l As New Location() With { _
              .Name = tbLocName.Text _
            }
            _calendar.Schedule.Locations.Add(l)
            tbLocName.Text = [String].Empty
            PopulateListBox()
        End If
    End Sub

    Protected Sub btnDelLoc_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim id As String = lstLocations.SelectedValue
        If Not [String].IsNullOrEmpty(id) Then
            Dim l As Location = _calendar.Schedule.Locations(id)
            If l IsNot Nothing Then
                _calendar.Schedule.Locations.Remove(l)
				If _calendar.Locations.Contains(l) Then
					_calendar.Locations.Remove(l)
				End If
                tbLocName.Text = [String].Empty
                PopulateListBox()

            End If
        End If
    End Sub

    Protected Sub btnFilterBy_Click(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.Locations.Clear()
        _calendar.Contacts.Clear()
        If lstContacts.SelectedIndex <> -1 Then
            ' Filter by selected contacts
            For i As Integer = 0 To lstContacts.Items.Count - 1
                Dim li = lstContacts.Items(i)
                If li.Selected Then
                    Dim c As Contact = _calendar.Schedule.Contacts(li.Value)
                    If Not _calendar.Contacts.Contains(c) Then
                        _calendar.Contacts.Add(c)
                    End If
                End If
            Next
            _calendar.GroupType = GroupType.FilterByContacts
        ElseIf lstLocations.SelectedIndex <> -1 Then
            ' Filter by selected locations
            For i As Integer = 0 To lstLocations.Items.Count - 1
                Dim li = lstLocations.Items(i)
                If li.Selected Then
                    Dim l As Location = _calendar.Schedule.Locations(li.Value)
                    If Not _calendar.Locations.Contains(l) Then
                        _calendar.Locations.Add(l)
                    End If
                End If
            Next
            _calendar.GroupType = GroupType.FilterByLocations
        End If
    End Sub
    Protected Sub btnGroupBy_Click(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.Locations.Clear()
        _calendar.Contacts.Clear()
        If lstContacts.SelectedIndex <> -1 Then
            ' Group by selected contacts
            For i As Integer = 0 To lstContacts.Items.Count - 1
                Dim li = lstContacts.Items(i)
                If li.Selected Then
                    Dim c As Contact = _calendar.Schedule.Contacts(li.Value)
                    If Not _calendar.Contacts.Contains(c) Then
                        _calendar.Contacts.Add(c)
                    End If
                End If
            Next
            _calendar.GroupType = GroupType.GroupByContacts
            tt_subHeaderSize.Enabled = True
            tt_subHeaderSize.ForeColor = Color.Black
        ElseIf lstLocations.SelectedIndex <> -1 Then
            ' Group by selected locations
            For i As Integer = 0 To lstLocations.Items.Count - 1
                Dim li = lstLocations.Items(i)
                If li.Selected Then
                    Dim l As Location = _calendar.Schedule.Locations(li.Value)
                    If Not _calendar.Locations.Contains(l) Then
                        _calendar.Locations.Add(l)
                    End If
                End If
            Next
            _calendar.GroupType = GroupType.GroupByLocations
            tt_subHeaderSize.Enabled = True
            tt_subHeaderSize.ForeColor = Color.Black
        End If
    End Sub
    Protected Sub btnClearGr_Click(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.Locations.Clear()
        _calendar.Contacts.Clear()
        _calendar.GroupType = GroupType.None
        tt_subHeaderSize.Enabled = False
        tt_subHeaderSize.ForeColor = Color.Gray
    End Sub

    Protected Sub _calendar_VisibleDateChanged(ByVal sender As Object, ByVal e As DateChangedEventArgs)
        ' Ensure the end date is 60 days after the start date
        _calendar.EndDate = e.NewDate + TimeSpan.FromDays(60)
        Session("_dates") = _calendar.TimetableSettings.Dates
    End Sub

#Region "SingleMonth"

    Protected Sub cblSinlgeMonth_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        If cblSinlgeMonth.Items(0).Selected Then
            _calendar.MonthSettings.HeaderStyle = _calendar.MonthSettings.HeaderStyle Or MindFusion.Scheduling.WebForms.MonthHeaderStyles.MonthButtons
        Else
            _calendar.MonthSettings.HeaderStyle = _calendar.MonthSettings.HeaderStyle And Not MindFusion.Scheduling.WebForms.MonthHeaderStyles.MonthButtons
        End If

        If cblSinlgeMonth.Items(1).Selected Then
            _calendar.MonthSettings.HeaderStyle = _calendar.MonthSettings.HeaderStyle Or MindFusion.Scheduling.WebForms.MonthHeaderStyles.YearButtons
        Else
            _calendar.MonthSettings.HeaderStyle = _calendar.MonthSettings.HeaderStyle And Not MindFusion.Scheduling.WebForms.MonthHeaderStyles.YearButtons
        End If

        If cblSinlgeMonth.Items(2).Selected Then
            _calendar.MonthSettings.DayNamesHeader = MindFusion.Scheduling.WebForms.State.Enabled
            sm_subHeaderSize.Enabled = True
            sm_subHeaderSize.ForeColor = Color.Black
        Else
            _calendar.MonthSettings.DayNamesHeader = MindFusion.Scheduling.WebForms.State.Disabled
            sm_subHeaderSize.Enabled = False
            sm_subHeaderSize.ForeColor = Color.Gray
        End If

        If cblSinlgeMonth.Items(3).Selected Then
            _calendar.MonthSettings.WeekHeaderStyle = MindFusion.Scheduling.WebForms.MonthWeekHeaderStyle.Left
            sm_weekHeaderSize.Enabled = True
            sm_weekHeaderSize.ForeColor = Color.Black
        Else
            _calendar.MonthSettings.WeekHeaderStyle = MindFusion.Scheduling.WebForms.MonthWeekHeaderStyle.None
            sm_weekHeaderSize.Enabled = False
            sm_weekHeaderSize.ForeColor = Color.Gray
        End If

        _calendar.MonthSettings.ShowPaddingDays = If(cblSinlgeMonth.Items(4).Selected, State.Enabled, State.Disabled)

        _calendar.MonthSettings.ShowPaddingItems = If(cblSinlgeMonth.Items(5).Selected, State.Enabled, State.Disabled)

    End Sub

    Protected Sub sm_mainHeaderSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(sm_mainHeaderSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(sm_mainHeaderSize.Text, result) Then
                _calendar.MonthSettings.MainHeaderHeight = New Unit(result, UnitType.Pixel)
            Else
                sm_mainHeaderSize.Text = _calendar.MonthSettings.MainHeaderHeight.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub sm_subHeaderSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(sm_subHeaderSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(sm_subHeaderSize.Text, result) Then
                _calendar.MonthSettings.DayNamesHeaderHeight = New Unit(result, UnitType.Pixel)
            Else
                sm_subHeaderSize.Text = _calendar.MonthSettings.DayNamesHeaderHeight.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub sm_weekHeaderSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(sm_weekHeaderSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(sm_weekHeaderSize.Text, result) Then
                _calendar.MonthSettings.WeekNumbersHeaderWidth = New Unit(result, UnitType.Pixel)
            Else
                sm_weekHeaderSize.Text = _calendar.MonthSettings.WeekNumbersHeaderWidth.Value.ToString()
            End If
        End If
    End Sub

#End Region

#Region "MonthRange"

    Protected Sub mr_numberOfMonths_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(mr_numberOfMonths.Text) Then
            Dim result As Integer
            If Integer.TryParse(mr_numberOfMonths.Text, result) Then
                _calendar.MonthRangeSettings.NumberOfMonths = result
            Else
                mr_numberOfMonths.Text = _calendar.MonthRangeSettings.NumberOfMonths.ToString()
            End If
        End If
    End Sub

    Protected Sub mr_monthsPerRow_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(mr_monthsPerRow.Text) Then
            Dim result As Integer
            If Integer.TryParse(mr_monthsPerRow.Text, result) Then
                _calendar.MonthRangeSettings.MonthsPerRow = result
            Else
                mr_monthsPerRow.Text = _calendar.MonthRangeSettings.MonthsPerRow.ToString()
            End If
        End If
    End Sub

    Protected Sub mr_VisibleRows_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(mr_VisibleRows.Text) Then
            Dim result As Integer
            If Integer.TryParse(mr_VisibleRows.Text, result) Then
                _calendar.MonthRangeSettings.VisibleRows = result
            Else
                mr_VisibleRows.Text = _calendar.MonthRangeSettings.VisibleRows.ToString()
            End If
        End If
    End Sub

    Protected Sub mr_headerHeight_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(mr_headerHeight.Text) Then
            Dim result As Integer
            If Integer.TryParse(mr_headerHeight.Text, result) Then
                _calendar.MonthRangeSettings.HeaderHeight = New Unit(result, UnitType.Pixel)
            Else
                mr_headerHeight.Text = _calendar.MonthRangeSettings.HeaderHeight.Value.ToString()
            End If
        End If
    End Sub
    Protected Sub mr_headerSpacing_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(mr_headerSpacing.Text) Then
            Dim result As Integer
            If Integer.TryParse(mr_headerSpacing.Text, result) Then
                _calendar.MonthRangeSettings.HeaderSpacing = result
            Else
                mr_headerSpacing.Text = _calendar.MonthRangeSettings.HeaderSpacing.ToString()
            End If
        End If
    End Sub

    Protected Sub mr_monthSpacing_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(mr_monthSpacing.Text) Then
            Dim result As Integer
            If Integer.TryParse(mr_monthSpacing.Text, result) Then
                _calendar.MonthRangeSettings.MonthSpacing = result
            Else
                mr_monthSpacing.Text = _calendar.MonthRangeSettings.MonthSpacing.ToString()
            End If
        End If
    End Sub

    Protected Sub mr_navButtons_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)
        If mr_navButtons.Checked Then
            _calendar.MonthRangeSettings.HeaderStyle = _calendar.MonthRangeSettings.HeaderStyle Or MonthRangeHeaderStyles.Buttons
        Else
            _calendar.MonthRangeSettings.HeaderStyle = _calendar.MonthRangeSettings.HeaderStyle And Not MonthRangeHeaderStyles.Buttons
        End If
    End Sub

#End Region

#Region "Timetable"

	Protected Sub ddlTimetableOrientation_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ddlTimetableOrientation.SelectedIndexChanged
		Dim ddl = TryCast(sender, DropDownList)
		Select Case ddl.SelectedIndex
			Case 0
				_calendar.TimetableSettings.Orientation = MindFusion.Scheduling.WebForms.Orientation.Horizontal
				Exit Select
			Case 1
				_calendar.TimetableSettings.Orientation = MindFusion.Scheduling.WebForms.Orientation.Vertical
				Exit Select
			Case Else
				Exit Select
		End Select
	End Sub

    Protected Sub cblTimetable_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.TimetableSettings.ShowNavigationButtons = If(cblTimetable.Items(0).Selected, State.Enabled, State.Disabled)
        _calendar.TimetableSettings.ShowDayHeader = If(cblTimetable.Items(1).Selected, State.Enabled, State.Disabled)
		_calendar.TimetableSettings.ShowExpandButton = If(cblTimetable.Items(2).Selected, State.Enabled, State.Disabled)
    End Sub

    Protected Sub tt_mainHeaderSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(tt_mainHeaderSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(tt_mainHeaderSize.Text, result) Then
                _calendar.TimetableSettings.MainHeaderSize = New Unit(result, UnitType.Pixel)
            Else
                tt_mainHeaderSize.Text = _calendar.TimetableSettings.MainHeaderSize.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub tt_subHeaderSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(tt_subHeaderSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(tt_subHeaderSize.Text, result) Then
                _calendar.TimetableSettings.GroupHeaderSize = New Unit(result, UnitType.Pixel)
            Else
                tt_subHeaderSize.Text = _calendar.TimetableSettings.GroupHeaderSize.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub tt_timelineSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(tt_timelineSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(tt_timelineSize.Text, result) Then
                _calendar.TimetableSettings.TimelineSize = New Unit(result, UnitType.Pixel)
            Else
                tt_timelineSize.Text = _calendar.TimetableSettings.TimelineSize.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub tt_cellSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(tt_cellSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(tt_cellSize.Text, result) Then
                _calendar.TimetableSettings.CellSize = New Unit(result, UnitType.Pixel)
            Else
                tt_cellSize.Text = _calendar.TimetableSettings.CellSize.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub tt_cellTime_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(tt_cellTime.Text) Then
            Dim result As Integer
            If Integer.TryParse(tt_cellTime.Text, result) Then
                If result > 0 AndAlso result <= 60 Then
                    _calendar.TimetableSettings.CellTime = TimeSpan.FromMinutes(result)
                End If
                tt_cellTime.Text = _calendar.TimetableSettings.CellTime.Minutes.ToString()
            Else
                tt_cellTime.Text = _calendar.TimetableSettings.CellTime.Minutes.ToString()
            End If
        End If
    End Sub

#End Region

#Region "List"

    Protected Sub ddlListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        Select Case ddl.SelectedIndex
            Case 0
                _calendar.ListViewSettings.CellUnits = TimeUnit.Second
                _calendar.ListViewSettings.TitleFormat = "dd MMM ddd,<br />hh:mm:ss"
                Exit Select
            Case 1
                _calendar.ListViewSettings.CellUnits = TimeUnit.Minute
                _calendar.ListViewSettings.TitleFormat = "dd MMM ddd,<br />hh:mm"
                Exit Select
            Case 2
                _calendar.ListViewSettings.CellUnits = TimeUnit.Hour
                _calendar.ListViewSettings.TitleFormat = "dd MMM ddd,<br />hh:mm"
                Exit Select
            Case 3
                _calendar.ListViewSettings.CellUnits = TimeUnit.Day
                _calendar.ListViewSettings.TitleFormat = "ddd,<br />dd MMM"
                Exit Select
            Case 4
                _calendar.ListViewSettings.CellUnits = TimeUnit.Week
                _calendar.ListViewSettings.TitleFormat = "ddd,<br />dd MMM"
                Exit Select
            Case 5
                _calendar.ListViewSettings.CellUnits = TimeUnit.Month
                _calendar.ListViewSettings.TitleFormat = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case 6
                _calendar.ListViewSettings.CellUnits = TimeUnit.Year
                _calendar.ListViewSettings.TitleFormat = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub

    Protected Sub lv_headerSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(lv_headerSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(lv_headerSize.Text, result) Then
                _calendar.ListViewSettings.MainHeaderSize = New Unit(result, UnitType.Pixel)
            Else
                lv_headerSize.Text = _calendar.ListViewSettings.MainHeaderSize.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub ddlListViewOrientation_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        Select Case ddl.SelectedIndex
            Case 0
                _calendar.ListViewSettings.Orientation = MindFusion.Scheduling.WebForms.Orientation.Horizontal
                Exit Select
            Case 1
                _calendar.ListViewSettings.Orientation = MindFusion.Scheduling.WebForms.Orientation.Vertical
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub

    Protected Sub lv_numberOfCells_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(lv_numberOfCells.Text) Then
            Dim result As Integer
            If Integer.TryParse(lv_numberOfCells.Text, result) Then
                _calendar.ListViewSettings.NumberOfCells = result
            Else
                lv_numberOfCells.Text = _calendar.ListViewSettings.NumberOfCells.ToString()
            End If
        End If
    End Sub

    Protected Sub lv_visibleCells_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(lv_visibleCells.Text) Then
            Dim result As Integer
            If Integer.TryParse(lv_visibleCells.Text, result) Then
                _calendar.ListViewSettings.VisibleCells = result
            Else
                lv_visibleCells.Text = _calendar.ListViewSettings.VisibleCells.ToString()
            End If
        End If
    End Sub

    Protected Sub lv_navButtons_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.ListViewSettings.ShowNavigationButtons = If(lv_navButtons.Checked, State.Enabled, State.Disabled)
    End Sub

    Protected Sub lv_dateFormat_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(lv_dateFormat.Text) Then
            Dim format As String = lv_dateFormat.Text
            _calendar.ListViewSettings.CellSettings.GeneralFormat = format
            _calendar.ListViewSettings.CellSettings.FirstDayOfMonthFormat = format
            _calendar.ListViewSettings.CellSettings.FirstDayOfYearFormat = format
        End If
    End Sub

#End Region

#Region "WeekRange"

    Protected Sub cblWeekRange_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim showMainHeader As Boolean = cblWeekRange.Items(0).Selected
        _calendar.WeekRangeSettings.HeaderStyle = If(showMainHeader, WeekRangeHeaderStyle.Title, WeekRangeHeaderStyle.None)
        wr_headerSize.Enabled = showMainHeader
        wr_headerSize.ForeColor = If(showMainHeader, Color.Black, Color.Gray)

        Dim showSubHeader As Boolean = cblWeekRange.Items(1).Selected
        _calendar.WeekRangeSettings.DayNamesHeader = If(showSubHeader, State.Enabled, State.Disabled)
        wr_subHeaderSize.Enabled = showSubHeader
        wr_subHeaderSize.ForeColor = If(showSubHeader, Color.Black, Color.Gray)
    End Sub

    Protected Sub wr_headerSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(wr_headerSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(wr_headerSize.Text, result) Then
                _calendar.WeekRangeSettings.MainHeaderHeight = New Unit(result, UnitType.Pixel)
            Else
                wr_headerSize.Text = _calendar.WeekRangeSettings.MainHeaderHeight.Value.ToString()
            End If
        End If
    End Sub
    Protected Sub wr_subHeaderSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(wr_subHeaderSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(wr_subHeaderSize.Text, result) Then
                _calendar.WeekRangeSettings.DayNamesHeaderHeight = New Unit(result, UnitType.Pixel)
            Else
                wr_subHeaderSize.Text = _calendar.WeekRangeSettings.DayNamesHeaderHeight.Value.ToString()
            End If
        End If
    End Sub
    Protected Sub wr_totalDays_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(wr_totalDays.Text) Then
            Dim result As Integer
            If Integer.TryParse(wr_totalDays.Text, result) Then
                _calendar.EndDate = _calendar.[Date].AddDays(result)
            Else
                wr_totalDays.Text = (_calendar.EndDate - _calendar.[Date]).TotalDays.ToString()
            End If
        End If
    End Sub

    Protected Sub wr_visibleRows_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(wr_visibleRows.Text) Then
            Dim result As Integer
            If Integer.TryParse(wr_visibleRows.Text, result) Then
                _calendar.WeekRangeSettings.VisibleRows = result
            Else
                wr_visibleRows.Text = _calendar.WeekRangeSettings.VisibleRows.ToString()
            End If
        End If
    End Sub

#End Region

#Region "ResourceView"
    Protected Sub r_timelines_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        _calendar.ResourceViewSettings.Timelines = (ddl.SelectedIndex + 1)
        r_mtunit.Enabled = r_timelines.SelectedIndex > 0
        r_mtcount.Enabled = r_timelines.SelectedIndex > 0
        r_mtsize.Enabled = r_timelines.SelectedIndex > 0
        r_ttunit.Enabled = r_timelines.SelectedIndex > 1
        r_ttcount.Enabled = r_timelines.SelectedIndex > 1
        r_ttsize.Enabled = r_timelines.SelectedIndex > 1
    End Sub

    Protected Sub r_visibleCells_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_visibleCells.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_visibleCells.Text, result) Then
                _calendar.ResourceViewSettings.VisibleCells = result
            Else
                r_visibleCells.Text = _calendar.ResourceViewSettings.VisibleCells.ToString()
            End If
        End If
    End Sub

    Protected Sub r_groupHeaderSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_groupHeaderSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_groupHeaderSize.Text, result) Then
                _calendar.ResourceViewSettings.GroupHeaderSize = New Unit(result, UnitType.Pixel)
            Else
                r_groupHeaderSize.Text = _calendar.ResourceViewSettings.GroupHeaderSize.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub r_ttunit_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        Select Case ddl.SelectedIndex
            Case 0
                _calendar.ResourceViewSettings.TopTimelineSettings.Unit = TimeUnit.Hour
                _calendar.ResourceViewSettings.TopTimelineSettings.Format = "dd MMM ddd,<br />hh:mm"
                Exit Select
            Case 1
                _calendar.ResourceViewSettings.TopTimelineSettings.Unit = TimeUnit.Day
                _calendar.ResourceViewSettings.TopTimelineSettings.Format = "ddd,<br />dd MMM"
                Exit Select
            Case 2
                _calendar.ResourceViewSettings.TopTimelineSettings.Unit = TimeUnit.Week
                _calendar.ResourceViewSettings.TopTimelineSettings.Format = "ddd,<br />dd MMM"
                Exit Select
            Case 3
                _calendar.ResourceViewSettings.TopTimelineSettings.Unit = TimeUnit.Month
                _calendar.ResourceViewSettings.TopTimelineSettings.Format = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case 4
                _calendar.ResourceViewSettings.TopTimelineSettings.Unit = TimeUnit.Year
                _calendar.ResourceViewSettings.TopTimelineSettings.Format = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub

    Protected Sub r_mtunit_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        Select Case ddl.SelectedIndex
            Case 0
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Unit = TimeUnit.Hour
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Format = "dd MMM ddd,<br />hh:mm"
                Exit Select
            Case 1
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Unit = TimeUnit.Day
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Format = "ddd,<br />dd MMM"
                Exit Select
            Case 2
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Unit = TimeUnit.Week
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Format = "ddd,<br />dd MMM"
                Exit Select
            Case 3
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Unit = TimeUnit.Month
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Format = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case 4
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Unit = TimeUnit.Year
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Format = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub

    Protected Sub r_btunit_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim ddl = TryCast(sender, DropDownList)
        Select Case ddl.SelectedIndex
            Case 0
                _calendar.ResourceViewSettings.BottomTimelineSettings.Unit = TimeUnit.Hour
                _calendar.ResourceViewSettings.BottomTimelineSettings.Format = "dd MMM ddd,<br />hh:mm"
                Exit Select
            Case 1
                _calendar.ResourceViewSettings.BottomTimelineSettings.Unit = TimeUnit.Day
                _calendar.ResourceViewSettings.BottomTimelineSettings.Format = "ddd,<br />dd MMM"
                Exit Select
            Case 2
                _calendar.ResourceViewSettings.BottomTimelineSettings.Unit = TimeUnit.Week
                _calendar.ResourceViewSettings.BottomTimelineSettings.Format = "ddd,<br />dd MMM"
                Exit Select
            Case 3
                _calendar.ResourceViewSettings.BottomTimelineSettings.Unit = TimeUnit.Month
                _calendar.ResourceViewSettings.BottomTimelineSettings.Format = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case 4
                _calendar.ResourceViewSettings.BottomTimelineSettings.Unit = TimeUnit.Year
                _calendar.ResourceViewSettings.BottomTimelineSettings.Format = "ddd,<br />dd MMM yyyy"
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub

    Protected Sub r_ttcount_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_ttcount.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_ttcount.Text, result) Then
                _calendar.ResourceViewSettings.TopTimelineSettings.UnitCount = result
            Else
                r_ttcount.Text = _calendar.ResourceViewSettings.TopTimelineSettings.UnitCount.ToString()
            End If
        End If
    End Sub

    Protected Sub r_mtcount_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_mtcount.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_mtcount.Text, result) Then
                _calendar.ResourceViewSettings.MiddleTimelineSettings.UnitCount = result
            Else
                r_mtcount.Text = _calendar.ResourceViewSettings.MiddleTimelineSettings.UnitCount.ToString()
            End If
        End If
    End Sub

    Protected Sub r_btcount_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_btcount.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_btcount.Text, result) Then
                _calendar.ResourceViewSettings.BottomTimelineSettings.UnitCount = result
            Else
                r_btcount.Text = _calendar.ResourceViewSettings.BottomTimelineSettings.UnitCount.ToString()
            End If
        End If
    End Sub

    Protected Sub r_ttsize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_ttsize.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_ttsize.Text, result) Then
                _calendar.ResourceViewSettings.TopTimelineSettings.Size = result
            Else
                r_ttsize.Text = _calendar.ResourceViewSettings.TopTimelineSettings.Size.ToString()
            End If
        End If
    End Sub

    Protected Sub r_mtsize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_mtsize.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_mtsize.Text, result) Then
                _calendar.ResourceViewSettings.MiddleTimelineSettings.Size = result
            Else
                r_mtsize.Text = _calendar.ResourceViewSettings.MiddleTimelineSettings.Size.ToString()
            End If
        End If
    End Sub

    Protected Sub r_btsize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(r_btsize.Text) Then
            Dim result As Integer
            If Integer.TryParse(r_btsize.Text, result) Then
                _calendar.ResourceViewSettings.BottomTimelineSettings.Size = result
            Else
                r_btsize.Text = _calendar.ResourceViewSettings.BottomTimelineSettings.Size.ToString()
            End If
        End If
    End Sub
#End Region

#Region "ItemSettings"

    Protected Sub cblItemSettings_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.ItemSettings.ItemsVisible = If(cblItemSettings.Items(0).Selected, State.Enabled, State.Disabled)
        _calendar.ItemSettings.ShowContinuationArrows = If(cblItemSettings.Items(1).Selected, State.Enabled, State.Disabled)
        _calendar.ItemSettings.ShowMoreItemsCue = If(cblItemSettings.Items(2).Selected, State.Enabled, State.Disabled)
        _calendar.ItemSettings.ShowReminderIcons = If(cblItemSettings.Items(3).Selected, State.Enabled, State.Disabled)
    End Sub

    Protected Sub is_size_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(is_size.Text) Then
            Dim result As Integer
            If Integer.TryParse(is_size.Text, result) Then
                _calendar.ItemSettings.Size = result
            Else
                is_size.Text = _calendar.ItemSettings.Size.ToString()
            End If
        End If
    End Sub

    Protected Sub is_spacing_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(is_spacing.Text) Then
            Dim result As Integer
            If Integer.TryParse(is_spacing.Text, result) Then
                _calendar.ItemSettings.Spacing = result
            Else
                is_spacing.Text = _calendar.ItemSettings.Spacing.ToString()
            End If
        End If
    End Sub

    Protected Sub is_headerSize_Changed(ByVal sender As Object, ByVal e As EventArgs)
        If Not [String].IsNullOrEmpty(is_headerSize.Text) Then
            Dim result As Integer
            If Integer.TryParse(is_headerSize.Text, result) Then
                _calendar.ItemSettings.HeaderSize = New Unit(result, UnitType.Pixel)
            Else
                is_headerSize.Text = _calendar.ItemSettings.HeaderSize.Value.ToString()
            End If
        End If
    End Sub

    Protected Sub is_class_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        _calendar.ItemSettings.CssClass = is_class.Items(is_class.SelectedIndex).Text
    End Sub

#End Region

    Private Shared ReadOnly singleMonthInfo As String = "This section contains information and samples about the SingleMonth view. That view displays a single month of the year at a time. The view can optionally display a header showing the month and year name, a header that shows the days of the week and a header that displays the week numbers. You can experiment with the controls at the bottom of the page to see how different aspects of the view can be modified."
    Private Shared ReadOnly monthRangeInfo As String = "Here you can see the MonthRange view, which is used to display several consecutive months at once. The view usually contains a header and optionally displays navigation buttons. Use the controls at the bottom of the window to change various appearance settings of this view."
    Private Shared ReadOnly weekRangeInfo As String = "Here you can see the WeekRange view. As its name suggests, this view is used to display a sequence of weeks arranged in 7-day rows. The number of days that can be contained in the view at once is unlimited. This view is very similar to the Calendar view in MS Outlook. As in the other steps, you can adjust some properties of this view using the controls at the bottom of the page. The WeekRange view supports two layouts for presenting dates - the single week layout and the multiple week layout. In the multiple week layout there are several weeks visible at the same time, each one displayed in its own row."
    Private Shared ReadOnly singleWeekInfo As String = "Here you can see the WeekRange view. As its name suggests, this view is used to display a sequence of weeks arranged in 7-day rows. The number of days that can be contained in the view at once is unlimited. This view is very similar to the Calendar view in MS Outlook. As in the other steps, you can adjust some properties of this view using the controls at the bottom of the page. The WeekRange view supports two layouts for presenting dates - the single week layout and the multiple week layout. In the single week layout, there is only one week shown at a time. The days of the displayed week are arranged in 2 columns and 3 rows."
    Private Shared ReadOnly timetableInfo As String = "This step illustrates the Timetable view. This view displays one or more days, divided in arbitrary time intervals from 1 to 60 minutes. The view can display a timeline on the left, and a header containing the date of each day at the top. Experiment with the controls at the bottom of the page to see how various elements of the view can be customized."
    Private Shared ReadOnly listInfo As String = "This is the List view. The List view is used to display an arbitrary long sequence of seconds, minutes, hours, days, weeks, months or years. The view provides a header displaying the date of the corresponding cell, formatted according to the calendar culture and a customizable formatting string. Use the controls at the bottom of the page to change some appearance options of this view."
    Private Shared ReadOnly resourceInfo As String = "This is the Resource view. This view displays the distribution of items over a period of time for particular contacts, locations, tasks or resources. The view displays a single row for each individual contact, location, task or resource and up to three timelines. In order to view associated items in this view, the GroupType property of the Calendar must be set to GroupByContacts, GroupByLocations, GroupByTasks or GroupByResources."


End Class